
#include "CursorGUI.h"
#include "Cursor.h"

//==============================================================================

void CursorGUI::paint(Graphics & g) {
  // Bouml preserved body begin 0003550D
	g.setColour(Colours::black);
	g.drawLine(getWidth()/2,0,getWidth()/2,getHeight(),2);
	g.drawLine(0,getHeight()/2,getWidth(),getHeight()/2,2);
	g.drawEllipse(6,6,getWidth()-12,getHeight()-12,2);
	g.setColour(Colours::white);
	g.drawEllipse(5,5,getWidth()-10,getHeight()-10,4);
  // Bouml preserved body end 0003550D
}

CursorGUI::CursorGUI(Cursor * cursor) 
:ModuleGUI(cursor)
{
  // Bouml preserved body begin 0003E20D
	this->setAlwaysOnTop(true);
	this->cursor = cursor;
	cursor->addChangeListener(this);
  // Bouml preserved body end 0003E20D
}

void CursorGUI::mouseDown(const MouseEvent & e) {
  // Bouml preserved body begin 0003F10D
	startDrag();
  // Bouml preserved body end 0003F10D
}

void CursorGUI::mouseDrag(const MouseEvent & e) {
  // Bouml preserved body begin 0003F18D
	this->drag(e);
	//this->refreshOriginalBounds();
  // Bouml preserved body end 0003F18D
}

void CursorGUI::mouseUp(const MouseEvent & e) {
  // Bouml preserved body begin 0003F20D
	
  // Bouml preserved body end 0003F20D
}

void CursorGUI::changeListenerCallback(void* objectThatHasChanged) {
  // Bouml preserved body begin 00047B0D
	if(objectThatHasChanged == cursor)
	{
		rePosition();
	}
  // Bouml preserved body end 00047B0D
}

CursorGUI::~CursorGUI() {
  // Bouml preserved body begin 00047B8D
	cursor->removeChangeListener(this);
  // Bouml preserved body end 00047B8D
}

