
#include "ModuleGUI.h"
#include "Module.h"
#include "ModulePane.h"

ModuleGUI::ModuleGUI(Module * module) {
  // Bouml preserved body begin 0003C20D
	this->module = module;
  // Bouml preserved body end 0003C20D
}

void ModuleGUI::mouseDrag(const MouseEvent & e) {
  // Bouml preserved body begin 0003B80D
	module->mouseDrag(e);
	if(e.mods.isLeftButtonDown())
	{
		for (int i = 0 ; i < pane->selectedModules.getNumSelected() ; i++)
		{
			pane->selectedModules.getSelectedItem(i)->drag(e);
		}
	}

  // Bouml preserved body end 0003B80D
}

void ModuleGUI::mouseUp(const MouseEvent & e) {
  // Bouml preserved body begin 0003B88D
	module->mouseUp(e);
	if(e.mods.isLeftButtonDown())
	{
		pane->selectedModules.addToSelectionOnMouseUp(this,e.mods,e.getDistanceFromDragStart()>0,this->selectionBool);
	}
  // Bouml preserved body end 0003B88D
}

void ModuleGUI::mouseDown(const MouseEvent & e) {
  // Bouml preserved body begin 0003B90D
	module->mouseDown(e);
	if(e.mods.isLeftButtonDown())
	{
		this->selectionBool = pane->selectedModules.addToSelectionOnMouseDown(this,e.mods);
		this->toFront(true);
		for (int i = 0 ; i < pane->selectedModules.getNumSelected() ; i++)
		{
			pane->selectedModules.getSelectedItem(i)->startDrag();
		}
	}
  // Bouml preserved body end 0003B90D
}

void ModuleGUI::setOriginalBounds(const Rectangle bounds) {
  // Bouml preserved body begin 0003DF8D
	module->setXY(bounds.getX(),bounds.getY());
  // Bouml preserved body end 0003DF8D
}

Rectangle ModuleGUI::getOriginalBounds() {
  // Bouml preserved body begin 0003DA8D
	return Rectangle(module->getX(),module->getY(),50,50);
  // Bouml preserved body end 0003DA8D
}

//==============================================================================

void ModuleGUI::paint(Graphics & g) {
  // Bouml preserved body begin 0003DC0D
	g.fillEllipse(0,0,getWidth(),getHeight());
	if(isSelected())
	{
		g.setColour(Colours::red);
		g.drawEllipse(0,0,getWidth(),getHeight(),2);
	}
  // Bouml preserved body end 0003DC0D
}

void ModuleGUI::setPane(ModulePane * pane) {
  // Bouml preserved body begin 0003DD0D
	this->pane = pane;
  // Bouml preserved body end 0003DD0D
}

void ModuleGUI::startDrag() {
  // Bouml preserved body begin 0003DE0D
	this->dragger.startDraggingComponent(this,0);
  // Bouml preserved body end 0003DE0D
}

void ModuleGUI::drag(const MouseEvent & e) {
  // Bouml preserved body begin 0003DE8D
	dragger.dragComponent(this,e);
	refreshOriginalBounds();
  // Bouml preserved body end 0003DE8D
}

bool ModuleGUI::isSelected() {
  // Bouml preserved body begin 0003E40D
	return this->pane->selectedModules.isSelected(this);
  // Bouml preserved body end 0003E40D
}

Module* ModuleGUI::getModule() {
  // Bouml preserved body begin 0003E88D
	return module;
  // Bouml preserved body end 0003E88D
}

