
#include "MorphPaneModel.h"
#include "Cursor.h"
#include "MidiMorph.h"
#include "Module.h"

MorphPaneModel::MorphPaneModel(MidiMorph * core) {
  // Bouml preserved body begin 0003CC0D
	this->core = core;
  // Bouml preserved body end 0003CC0D
}

int MorphPaneModel::getNumModules() {
  // Bouml preserved body begin 0003CE0D
	return core->scenes.size();
  // Bouml preserved body end 0003CE0D
}

void MorphPaneModel::mouseDown(const MouseEvent & e) {
  // Bouml preserved body begin 0003D20D

  // Bouml preserved body end 0003D20D
}

void MorphPaneModel::mouseUp(const MouseEvent & e) {
  // Bouml preserved body begin 0003D28D
	if(e.mods.isRightButtonDown())
	{	
		PopupMenu menu;
		menu.addItem(1,"add scene");
		menu.addItem(5,"add controller");
		menu.addSeparator();
		menu.addItem(2,"Midi Out Refresh Rate:" + String(core->refreshRate));
		menu.addItem(3,"auto-learn Controller",true,core->autoLearn);
		menu.addItem(4,"auto-key Scene",true,core->autoKey);
		menu.addSeparator();
		menu.addItem(6,"audit selected Scene",true,core->getAuditSelScene());
		menu.addItem(7,"select all");

		int result = menu.show();
		if(result == 1)
		{
			Scene* ns = new Scene(core);
			ns->setXY(e.x,e.y);
			core->addScene(ns);
		}
		else if(result == 2)
		{
			Slider slider(T(""));
			slider.setRange(1,5000,1);
			slider.setSize(200,25);
			slider.setValue(core->refreshRate);
			DialogWindow::showModalDialog("",&slider,0,Colours::white,true);
			core->refreshRate = slider.getValue();
			//deleteAndZero(slider)

		}
		else if(result == 3)
		{
			core->autoLearn = ! core->autoLearn;
		}
		else if(result == 4)
		{
			core->autoKey = ! core->autoKey;
		}
		else if(result==5)
		{
			core->addController();
		}
		else if(result==6)
		{
			core->setAuditSelScene(! core->getAuditSelScene());
		}
		else if(result==7)
		{
			ApplicationCommandTarget::InvocationInfo info (1);
			performCommand(info);
		}
		
	}
  // Bouml preserved body end 0003D28D
}

Module* MorphPaneModel::getModule(int index) {
  // Bouml preserved body begin 0003D80D
	return core->scenes[index];
  // Bouml preserved body end 0003D80D
}

ModuleGUI* MorphPaneModel::createGUI(int index) {
  // Bouml preserved body begin 0003D98D
	return 0;
  // Bouml preserved body end 0003D98D
}

void MorphPaneModel::selectionChanged(const Array<ModuleGUI*> & modules) {
  // Bouml preserved body begin 0003E78D
	Array<Scene*> scenes;
	for (int i = 0 ; i < modules.size(); i++)
	{
		scenes.add( (Scene*)modules[i]->getModule() );
	}
	core->setSelectedScenes(scenes);
  // Bouml preserved body end 0003E78D
}

