#pragma once


#include "Module.h"
#include "juce.h"

class MidiMorph;
class ControllerValue;
class Controller;
namespace juce { class MidiBuffer; } 
class Cursor;

class Scene : public Module {
  public:
    Scene(const Scene & scene);

    Scene(MidiMorph * core);

     ~Scene();


  private:
    //stored for performance reason
    float distanceFromCursor;

    float affectionRatio;

    float affectionValue;

    bool distanceFromCursorChanged_;

    bool affectionRatioChanged;

    bool affectionValueChanged;

    Array<ControllerValue*> controllerValues;

    MidiMorph* core;


  public:
    float getAffectionRatio();

    //get Precalculated Value
    float getDistanceFromCursor();

    int getValue(const Controller* controller);

    //gets called when the XYItem gets new coordinates
    //in this implementation refresh the distance value
    virtual void moved();

    juce::Colour getColour();

    void setColour(const juce::Colour & colour);

    void addValue( ControllerValue * value);

    float getAffectionValue();

    void distanceFromCursorChanged();

    void mouseDown(const MouseEvent & e);

    void mouseUp(const MouseEvent & e);

    void getMidiMessages(juce::MidiBuffer & buffer, int pos);

    void mouseDrag(const MouseEvent & e);

    int getId();

  friend class ControllerValue;
    int id;

};

